<?php

namespace app\common\model\Home;

use app\common\arw\adjfut\src\Validate;
use app\BaseModel;
use think\model\concern\SoftDelete;
use app\common\arw\adjfut\src\Excel;
use app\Request;
use app\common\exception\Tool;
use think\facade\Db;

class HomeEnv extends BaseModel
{
    use SoftDelete;
    // 删除字段
    protected $deleteTime = 'home_env_delete_time';
    // 设置主键名
    protected $pk = 'home_env_guid';
    // 设置废弃字段
    protected $disuse = [];
    // 设置字段信息
    protected $schema = [
        'home_env_id' => 'int',
        'home_env_guid' => 'string',
        'home_env_img' => 'string',
        'home_env_sort' => 'string',
        'home_env_create_time' => 'datetime',
        'home_env_create_user_guid' => 'string',
        'home_env_update_time' => 'datetime',
        'home_env_update_user_guid' => 'string',
        'home_env_delete_time' => 'datetime',
        'home_env_delete_user_guid' => 'string',

    ];
    // 设置json类型字段
    protected $json = [''];
    // 开启自动写入时间戳字段
    protected $autoWriteTimestamp = 'datetime';
    // 创建时间
    protected $createTime = 'home_env_create_time';
    // 修改时间
    protected $updateTime = 'home_env_update_time';


    //排序字段
    public $order_field = 'home_env_sort';

    /**
     * 新增前
     */
    public static function onBeforeInsert(self $model): void
    {
        Tool::sortInsertProc(
            self::class,
            $model->home_env_sort,
        );
        $model->completeCreateField();
    }

    /**
     * 更新前
     */
    public static function onBeforeUpdate(self $model): void
    {
        Tool::sortEditProc(
            self::class,
            $model->home_env_guid,
            $model->home_env_sort,
        );
        $model->completeUpdateField();
    }

    /**
     * 删除前
     */
    public static function onBeforeDelete(self $model): void
    {
        Tool::sortDeleteProc(self::class, $model->home_env_guid);
        $model->completeDeleteField();
    }


    /**
     * 导出Excel
     * 
     * @param array $select 导出的数据
     */
    public static function exportExcel(array $select): void
    {
        $data = [[
            '图片',
            '排序'
        ]];
        foreach ($select as $key => $val) {
            $data[] = [
                Excel::ExportImgFiled($val['home_env_img']),
                $val['home_env_sort'],
            ];
        }
        $excel = (new Excel())->exporTsheet($data);
        $excel->save('首页环境.xlsx');
    }
}
